searchNodes=[{"doc":"Module documentation for Memoize.","ref":"Memoize.html","title":"Memoize","type":"module"},{"doc":"","ref":"Memoize.html#cache_strategy/0","title":"Memoize.cache_strategy/0","type":"function"},{"doc":"Define the memoized function.Below code:defmemo foo(0, y) do y end defmemo foo(x, y) when x == 1 do y * z end defmemo foo(x, y, z \\\\ 0) when x == 2 do y * z endis converted to:def foo(t1, t2) do Memoize.Cache.get_or_run({__MODULE__, :foo, [t1, t2]}, fn -&gt; __foo_memoize(t1, t2) end) end def foo(t1, t2, t3) do Memoize.Cache.get_or_run({__MODULE__, :foo, [t1, t2, t3]}, fn -&gt; __foo_memoize(t1, t2, t3) end) end def __foo_memoize(0, y) do y end def __foo_memoize(x, y) when x == 1 do y * z end def __foo_memoize(x, y, z \\\\ 0) when x == 2 do y * z end","ref":"Memoize.html#defmemo/2","title":"Memoize.defmemo/2","type":"macro"},{"doc":"","ref":"Memoize.html#defmemo/3","title":"Memoize.defmemo/3","type":"macro"},{"doc":"","ref":"Memoize.html#defmemop/2","title":"Memoize.defmemop/2","type":"macro"},{"doc":"","ref":"Memoize.html#defmemop/3","title":"Memoize.defmemop/3","type":"macro"},{"doc":"See Memoize.Cache.garbage_collect/0.","ref":"Memoize.html#garbage_collect/0","title":"Memoize.garbage_collect/0","type":"function"},{"doc":"","ref":"Memoize.html#invalidate/0","title":"Memoize.invalidate/0","type":"function"},{"doc":"","ref":"Memoize.html#invalidate/1","title":"Memoize.invalidate/1","type":"function"},{"doc":"","ref":"Memoize.html#invalidate/2","title":"Memoize.invalidate/2","type":"function"},{"doc":"","ref":"Memoize.html#invalidate/3","title":"Memoize.invalidate/3","type":"function"},{"doc":"Module documentation for Memoize.Cache.","ref":"Memoize.Cache.html","title":"Memoize.Cache","type":"module"},{"doc":"","ref":"Memoize.Cache.html#garbage_collect/0","title":"Memoize.Cache.garbage_collect/0","type":"function"},{"doc":"","ref":"Memoize.Cache.html#get_or_run/3","title":"Memoize.Cache.get_or_run/3","type":"function"},{"doc":"","ref":"Memoize.Cache.html#invalidate/0","title":"Memoize.Cache.invalidate/0","type":"function"},{"doc":"","ref":"Memoize.Cache.html#invalidate/1","title":"Memoize.Cache.invalidate/1","type":"function"},{"doc":"A behaviour module for implementing cache strategy.","ref":"Memoize.CacheStrategy.html","title":"Memoize.CacheStrategy","type":"behaviour"},{"doc":"","ref":"Memoize.CacheStrategy.html#c:cache/3","title":"Memoize.CacheStrategy.cache/3","type":"callback"},{"doc":"","ref":"Memoize.CacheStrategy.html#configured?/1","title":"Memoize.CacheStrategy.configured?/1","type":"function"},{"doc":"","ref":"Memoize.CacheStrategy.html#c:garbage_collect/0","title":"Memoize.CacheStrategy.garbage_collect/0","type":"callback"},{"doc":"","ref":"Memoize.CacheStrategy.html#c:init/0","title":"Memoize.CacheStrategy.init/0","type":"callback"},{"doc":"","ref":"Memoize.CacheStrategy.html#c:init/1","title":"Memoize.CacheStrategy.init/1","type":"callback"},{"doc":"","ref":"Memoize.CacheStrategy.html#c:invalidate/0","title":"Memoize.CacheStrategy.invalidate/0","type":"callback"},{"doc":"","ref":"Memoize.CacheStrategy.html#c:invalidate/1","title":"Memoize.CacheStrategy.invalidate/1","type":"callback"},{"doc":"","ref":"Memoize.CacheStrategy.html#c:read/3","title":"Memoize.CacheStrategy.read/3","type":"callback"},{"doc":"","ref":"Memoize.CacheStrategy.html#c:tab/1","title":"Memoize.CacheStrategy.tab/1","type":"callback"},{"doc":"","ref":"Memoize.CacheStrategy.Eviction.html","title":"Memoize.CacheStrategy.Eviction","type":"module"},{"doc":"Callback implementation for Memoize.CacheStrategy.cache/3.","ref":"Memoize.CacheStrategy.Eviction.html#cache/3","title":"Memoize.CacheStrategy.Eviction.cache/3","type":"function"},{"doc":"","ref":"Memoize.CacheStrategy.Eviction.html#clear_expired_cache/2","title":"Memoize.CacheStrategy.Eviction.clear_expired_cache/2","type":"function"},{"doc":"Callback implementation for Memoize.CacheStrategy.garbage_collect/0.","ref":"Memoize.CacheStrategy.Eviction.html#garbage_collect/0","title":"Memoize.CacheStrategy.Eviction.garbage_collect/0","type":"function"},{"doc":"Callback implementation for Memoize.CacheStrategy.init/1.","ref":"Memoize.CacheStrategy.Eviction.html#init/1","title":"Memoize.CacheStrategy.Eviction.init/1","type":"function"},{"doc":"Callback implementation for Memoize.CacheStrategy.invalidate/0.","ref":"Memoize.CacheStrategy.Eviction.html#invalidate/0","title":"Memoize.CacheStrategy.Eviction.invalidate/0","type":"function"},{"doc":"Callback implementation for Memoize.CacheStrategy.invalidate/1.","ref":"Memoize.CacheStrategy.Eviction.html#invalidate/1","title":"Memoize.CacheStrategy.Eviction.invalidate/1","type":"function"},{"doc":"Callback implementation for Memoize.CacheStrategy.read/3.","ref":"Memoize.CacheStrategy.Eviction.html#read/3","title":"Memoize.CacheStrategy.Eviction.read/3","type":"function"},{"doc":"Callback implementation for Memoize.CacheStrategy.tab/1.","ref":"Memoize.CacheStrategy.Eviction.html#tab/1","title":"Memoize.CacheStrategy.Eviction.tab/1","type":"function"},{"doc":"","ref":"Memoize.CacheStrategy.Eviction.html#used_bytes/0","title":"Memoize.CacheStrategy.Eviction.used_bytes/0","type":"function"},{"doc":"Changelog","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"","ref":"changelog.html#develop","title":"Changelog - develop","type":"extras"},{"doc":"Add the default value of :expires_in configurable.Remove compile-time config.","ref":"changelog.html#1-4-0-2021-07-30","title":"Changelog - 1.4.0 2021-07-30","type":"extras"},{"doc":"Fix infinite loop if cache process crashes (#14)@davorbadrov","ref":"changelog.html#1-3-3-2021-02-03","title":"Changelog - 1.3.3 2021-02-03","type":"extras"},{"doc":"Replace is_exception/1 to Exception.exception?/1.","ref":"changelog.html#1-3-2-2020-10-09","title":"Changelog - 1.3.2 2020-10-09","type":"extras"},{"doc":"Require Elixir &gt;= 1.9Fix warnings for Elixir 1.11Fix freeze when exit or throw (#13)Update dependencies","ref":"changelog.html#1-3-1-2020-10-07","title":"Changelog - 1.3.1 2020-10-07","type":"extras"},{"doc":"Limit count of waiter processes that receive message passingUpdate dependencies","ref":"changelog.html#1-3-0-2018-10-31","title":"Changelog - 1.3.0 2018-10-31","type":"extras"},{"doc":"Fix defmemo unquote(name)() doesn't work","ref":"changelog.html#1-2-8-2018-07-21","title":"Changelog - 1.2.8 2018-07-21","type":"extras"},{"doc":"Update dependencies","ref":"changelog.html#1-2-7-2018-04-16","title":"Changelog - 1.2.7 2018-04-16","type":"extras"},{"doc":"Apply Elixir formatter","ref":"changelog.html#1-2-6-2018-01-23","title":"Changelog - 1.2.6 2018-01-23","type":"extras"},{"doc":"Update a dependency ex_docImprove documents","ref":"changelog.html#1-2-5-2018-01-06","title":"Changelog - 1.2.5 2018-01-06","type":"extras"},{"doc":"Fix map type is passed to :ets.select_replace/2Improve documents","ref":"changelog.html#1-2-4-2017-10-22","title":"Changelog - 1.2.4 2017-10-22","type":"extras"},{"doc":"Fix passing map type to :ets.select_replace/2","ref":"changelog.html#1-2-3-2017-09-28","title":"Changelog - 1.2.3 2017-09-28","type":"extras"},{"doc":"Memoize A memoization macro for Elixir.&quot;In computing, memoization or memoisation is an optimization technique used primarily to speed up computer programs by storing the results of expensive function calls and returning the cached result when the same inputs occur again.&quot;Source: https://en.wikipedia.org/wiki/Memoization","ref":"readme.html","title":"Memoize","type":"extras"},{"doc":"Elixir 1.9 or later.Erlang/OTP 21.2 or later.","ref":"readme.html#requirement","title":"Memoize - Requirement","type":"extras"},{"doc":"Add :memoize to your mix.exs dependencies:defp deps do [ {:memoize, &quot;~&gt; 1.4&quot;} ] end","ref":"readme.html#installation","title":"Memoize - Installation","type":"extras"},{"doc":"If you want to cache a function, use Memoize on the module and change def to defmemo.For example:defmodule Fib do def fibs(0), do: 0 def fibs(1), do: 1 def fibs(n), do: fibs(n - 1) + fibs(n - 2) endThis code changes to:defmodule Fib do use Memoize defmemo fibs(0), do: 0 defmemo fibs(1), do: 1 defmemo fibs(n), do: fibs(n - 1) + fibs(n - 2) endIf a function defined by defmemo raises an error, the result is not cached and one of waiting processes will call the function.","ref":"readme.html#how-to-memoize","title":"Memoize - How to memoize","type":"extras"},{"doc":"A caching function that is defined by defmemo is never called in parallel.defmodule Calc do use Memoize defmemo calc() do Process.sleep(1000) IO.puts &quot;called!&quot; end end # call `Calc.calc/0` in parallel using many processes. for _ &lt;- 1..10000 do Process.spawn(fn -&gt; Calc.calc() end, []) end # but, actually `Calc.calc/0` is called only once.","ref":"readme.html#exclusive","title":"Memoize - Exclusive","type":"extras"},{"doc":"If you want to invalidate cache, you can use Memoize.invalidate/{0-3}.# invalidate a cached value of `Fib.fibs(0)`. Memoize.invalidate(Fib, :fibs, [0]) # invalidate all cached values of `Fib.fibs/1`. Memoize.invalidate(Fib, :fibs) # invalidate all cached values of `Fib` module. Memoize.invalidate(Fib) # invalidate all cached values. Memoize.invalidate()Notice: Memoize.invalidate/{0-2}'s complexity is linear. Therefore, it takes a long time if Memoize has many cached values.","ref":"readme.html#invalidate","title":"Memoize - Invalidate","type":"extras"},{"doc":"If you want to cache with partial arguments, use Memoize.Cache.get_or_run/2 directly.defmodule Converter do def convert(unique_key, data) do Memoize.Cache.get_or_run({__MODULE__, :resolve, [unique_key]}, fn -&gt; do_convert(data) end) end end","ref":"readme.html#caching-partial-arguments","title":"Memoize - Caching Partial Arguments","type":"extras"},{"doc":"Cache strategy is a behaviour to management cached values.By default, the caching strategy is Memoize.CacheStrategy.Default.If you want to change the caching strategy, configure :cache_strategy in :memoize application.config :memoize, cache_strategy: Memoize.CacheStrategy.Evictionmemoize provides below caching strategies.Memoize.CacheStrategy.DefaultMemoize.CacheStrategy.Eviction","ref":"readme.html#cache-strategy","title":"Memoize - Cache Strategy","type":"extras"},{"doc":"Default caching strategy. It provides only simple and fast features.Basically, cached values are not collected automatically. To collect cached values, call invalidate/{0-4}, call garbage_collect/0 or specify :expires_in with defmemo.ExpirationIf you want to invalidate the cache after a certain period of time, you can use :expires_in.defmodule Api do use Memoize defmemo get_config(), expires_in: 60 * 1000 do call_external_api() end endThe cached value is invalidated in the first get_config/0 function call after expires_in milliseconds have elapsed.To collect expired values, you can use garbage_collect/0. It collects all expired values. Its complexity is linear.The default value of :expires_in is configurable as below:config :memoize, cache_strategy: Memoize.CacheStrategy.Default config :memoize, Memoize.CacheStrategy.Default, expires_in: 600_000 # 10 minutes","ref":"readme.html#cache-strategy-memoize-cachestrategy-default","title":"Memoize - Cache Strategy - Memoize.CacheStrategy.Default","type":"extras"},{"doc":"Memoize.CacheStrategy.Eviction is one of caching strategy. It provides many features, but slower than Memoize.CacheStrategy.Default.The strategy is, basically, if cached memory size is exceeded max_threshold, unused cached values are collected until memory size falls below min_threshold.To use Memoize.CacheStrategy.Eviction, configure :cache_strategy as below:config :memoize, cache_strategy: Memoize.CacheStrategy.Eviction config :memoize, Memoize.CacheStrategy.Eviction, min_threshold: 5_000_000, max_threshold: 10_000_000PermanentlyIf :permanent option is specified with defmemo, the value won't be collected automatically. If you want to remove the value, call invalidate/{0-3}.defmodule Json do use Memoize defmemo get_json(filename), permanent: true do filename |&gt; File.read!() |&gt; Poison.decode!() end endNotice the permanent value includes in used memory size. So you should adjust min_threshold value.ExpirationIf :expires_in option is specified with defmemo, the value will be collected after :expires_in milliseconds. To be exact, when the read/3 function is called with any arguments, all expired values will be collected.defmodule Api do use Memoize defmemo get_config(), expires_in: 60 * 1000 do call_external_api() end endYou can both specify :permanent and :expires_in. In the case, the cached value is not collected by garbage_collect/0 or memory size that exceed max_threshold, but after :expires_in milliseconds it is collected.","ref":"readme.html#cache-strategy-memoize-cachestrategy-eviction","title":"Memoize - Cache Strategy - Memoize.CacheStrategy.Eviction","type":"extras"},{"doc":"You can customize caching strategy.defmodule Memoize.CacheStrategy do @callback init() :: any @callback tab(any) :: atom @callback cache(any, any, Keyword.t) :: any @callback read(any, any, any) :: :ok | :retry @callback invalidate() :: integer @callback invalidate(any) :: integer @callback garbage_collect() :: integer endIf you want to use a customized caching strategy, implement Memoize.CacheStrategy behaviour.defmodule YourAwesomeApp.ExcellentCacheStrategy do @behaviour Memoize.CacheStrategy def init() do ... end ... endThen, configure :cache_strategy in :memoize application.config :memoize, cache_strategy: YourAwesomeApp.ExcellentCacheStrategyNotice tab/1, read/3, invalidate/{0-1}, garbage_collect/0 are called concurrently. cache/3 is not called concurrently, but other functions are called concurrently while cache/3 is called by a process.init/0When application is started, init/0 is called only once.tab/1To determine which ETS tab to use, Memoize calls tab/0.cache/3When new value is cached, cache/3 will be called. The first argument is key that is used as cache key. The second argument is value that is calculated value by cache key. The third argument is opts that is passed by defmemo.cache/3 can return an any value that is called context. context is stored to ETS. And then, the context is passed to read/3's third argument.read/3When a value is looked up by a key, read/3 will be called. first and second arguments are same as cache/3. The third argument is context that is created at cache/3.read/3 can return :retry or :ok. If :retry is returned, retry the lookup. If :ok is returned, return the value.invalidte/{0,1}These functions are called from Memoize.invalidate/{0-4}.garbage_collect/0The function is called from Memoize.garbage_collect/0.","ref":"readme.html#cache-strategy-your-strategy","title":"Memoize - Cache Strategy - Your Strategy","type":"extras"},{"doc":"Normally, waiter processes are waiting at the end of the computing process using message passing. However, As the number of waiting processes increases, memory is consumed, so we limit this number of the waiters.Number of waiter processes receiving message passing are configured as config.exs or defmemo opts. (prior defmemo).With config.exs:config :memoize, max_waiter: 100, waiter_sleep_ms: 1000With defmemo opts:defmemo foo(), max_waiter: 100, waiter_sleep_ms: 1000 do ... end:max_waiters: Number of waiter processes receiving message passing. (default: 20):waiter_sleep_ms: Time to sleep when the number of waiter processes exceeds :max_waiters. (default: 200)","ref":"readme.html#waiter-config","title":"Memoize - Waiter config","type":"extras"},{"doc":"Memoize is using CAS (compare-and-swap) on ETS.CAS is now available in Erlang/OTP 20.","ref":"readme.html#internal","title":"Memoize - Internal","type":"extras"},{"doc":"Copyright (c) 2017 melponThis library is MIT licensed. See the LICENSE for details.","ref":"readme.html#license","title":"Memoize - License","type":"extras"}]